# --------------------------------------------------------------------------
# PyTeddy version .9 Apr 14, 2005
# Program versions: Blender 2.36+
# --------------------------------------------------------------------------
# ***** BEGIN GPL LICENSE BLOCK *****
#
# Copyright (C) 2005: Vamsi Krishna.V vkrishna _at_ research.iiit.ac.in, vkrishna _at_students.iiit.ac.in
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****
# --------------------------------------------------------------------------

#from OpenGL.GL import *
#from OpenGL.GLU import *

import sys
import math

import model
import poly 

skpoints = []
skadjecent = []
boneidval = -1
class Bone:
	def __init__( self, pt = model.Point3D( ), parent=None ):
		self.pt = pt
		self.children = []
		globals()["boneidval"] = globals()["boneidval"] + 1
		self.id = globals( )["boneidval"]
		self.parent = parent 
		self.deleted = False

	def addBone( self, pt ):
		pass
	
	def writeBone( self, fp ):
		fp.write( "<BONE ID=\""+str(self.id)+"\" NAME=\"\" NUMCHILDS=\""+str(len(self.children))+"\">\n" )

#fp.write( "\t<TRANSLATION>"+str(self.pt.x)+" "+str(self.pt.y)+"0</TRANSLATION>\n" ) 
		if( self.parent == None ):
		#	fp.write( "\t<TRANSLATION>"+str(self.pt.x)+" "+str(self.pt.y)+"0</TRANSLATION>\n" ) 
			fp.write( "\t<TRANSLATION>"+str(self.pt.x)+" "+"0 "+str(self.pt.y)+"</TRANSLATION>\n" ) 
		else:
			fp.write( "\t<TRANSLATION>"+str(self.pt.x-self.parent.pt.x)+" 0 "+str(self.pt.y-self.parent.pt.y)+"</TRANSLATION>\n" ) 
		#	fp.write( "\t<TRANSLATION>"+str(self.pt.x-self.parent.pt.x)+" "+str(self.pt.y-self.parent.pt.y)+"0</TRANSLATION>\n" ) 
		fp.write( "\t<ROTATION>0 0 0 1</ROTATION>\n" ) 
		fp.write( "\t<LOCALTRANSLATION>0 0 0</LOCALTRANSLATION>\n" ) 
		fp.write( "\t<LOCALROTATION>0 0 0 1</LOCALROTATION>\n" ) 
		if( self.parent == None ):
			fp.write( "\t<PARENTID>-1</PARENTID>\n" )
		else:	
			fp.write( "\t<PARENTID>"+str(self.parent.id)+"</PARENTID>\n" )	

		for child in self.children:
			fp.write( "\t<CHILDID>"+str(child.id)+"</CHILDID>\n" );
		fp.write( "</BONE>\n")
		#write the children bones as well
		for child in self.children:
			child.writeBone( fp )
	
#	def renderBone( self ):
#		for child in self.children:
#			child.renderBone( )
#		if not(self.parent==None):		
#			glBegin( GL_LINES )
#			glColor3f( 0, 0, 1 )
#			glVertex2f( self.parent.pt.x, self.parent.pt.y )
#			glColor3f( 1, 1, 1 )
#			glVertex2f( self.pt.x, self.pt.y )
#			glEnd( )
#		else:
#			glColor3f( 1, 0, 0 )
#			glBegin( GL_POINT )
#			glVertex2f( self.pt.x, self.pt.y )
#			glEnd( )

	def optimizeBone( self ):
			#nodes with single child are responsible for
			#straight lines of small bones
			print "Children",len(self.children)
			if len(self.children) == 1:
				print "Found Bone with one child"
				if self.parent == None:
					self.children[0].optimizeBone( )
				else:
					p1 = self.parent.pt
					p2 = self.pt
					p3 = self.children[0].pt
					#vectors originating from p2 towards p1 and p3
					v1 = [ p1.x-p2.x, p1.y-p2.y, p1.z-p2.z ]
					v2 = [ p3.x-p2.x, p3.y-p2.y, p3.z-p2.y ] 
					v1_magnitude = math.sqrt( v1[0]*v1[0] + v1[1]*v1[1] + v1[2]*v1[2] )
					v2_magnitude = math.sqrt( v2[0]*v2[0] + v2[1]*v2[1] + v2[2]*v2[2] )
					cos_val = ( v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2] )/( v1_magnitude * v2_magnitude )
					print "cos_val", cos_val
					if math.fabs(cos_val) <= 0.1 :
						print "deleted this node"
						self.deleted = True
						#self.children[0].parent = self.parent
						self.children[0].optimizeBone( )
			else:
				for child in self.children:
					child.optimizeBone( )

#	def remakeTree( self ):
#			if self.parent == None:
#				newchildren = []
#				for child in self.children:
#					newchild = child.remakeTree( )	
#					newchild.parent = self
#					newchildren.append( newchild )
#				self.children = newchildren
#			else:
#				if self.deleted:
#					return children[0].remakeTree( )
					
	def printBone( self, fp ):
		for child in self.children:
			fp.write( str(self.pt.x)+" "+str(self.pt.y)+" "+str(child.pt.x)+" "+str(child.pt.y) +"\n")
			child.printBone(fp)	

#return all the children to this pt
def findChildren( skeleton, bone ):
	points = []		#contains the bones connected to this point
	newlines = []	#contains the bones not connected to this point
	pt = bone.pt
	for line in skeleton:
		if poly.isEqualPoint(line.p1,pt):
			points.append( Bone(line.p2, bone) )
		elif poly.isEqualPoint(line.p2,pt):
			points.append( Bone(line.p1, bone) )
		else: 
			newlines.append( line )
	skeleton = newlines
	return (newlines, points)
	
def getIndex( pt ):
	for i in xrange(len(skpoints)):
		if skpoints[i] is pt:
			return i

def writeSkel( skeleton, cal3Dskeleton ):
	fp = open( "teddy.xsf", "w" )
	fp.write( "<SKELETON VERSION=\"1000\" NUMBONES=\""+str(len(skeleton))+"\">\n")
	cal3Dskeleton.writeBone( fp )
	fp.close()				
		
def makeTree( bone, sklines ):
	(sklines, bone.children) = findChildren( sklines, bone )
	for child in bone.children:
		child = makeTree( child, sklines )
	return bone

def genCal3DSkel( skeleton ):
	global skpoints
	sklines = []
	maxpoint = model.Point3D( )
	print "LEN OF SKEL", len(skeleton)
	fp = open( "points.txt", "w" )
	for skline in skeleton:
		fp.write( str(skline.p1.x) + " " + str(skline.p1.y) + " " )
		fp.write( str(skline.p2.x) + " " + str(skline.p2.y) + "\n" )
		if( maxpoint.y < skline.p1.y ):
			maxpoint.x = skline.p1.x
			maxpoint.y = skline.p1.y
		if( maxpoint.y < skline.p2.y ):
			maxpoint.x = skline.p2.x
			maxpoint.y = skline.p2.y
		sklines.append(skline)
	fp.close( )
	
	cal3Dskeleton = Bone( maxpoint, None )
	cal3Dskeleton = makeTree( cal3Dskeleton, sklines )
	writeSkel( skeleton, cal3Dskeleton )
	return cal3Dskeleton
#	fp = open("points.txt", "w" )
#	cal3Dskeleton.printBone( fp )
#	fp.close( )
				
