# --------------------------------------------------------------------------
# PyTeddy version .9 Apr 14, 2005
# Program versions: Blender 2.36+
# --------------------------------------------------------------------------
# ***** BEGIN GPL LICENSE BLOCK *****
#
# Copyright (C) 2005: Vamsi Krishna.V vkrishna _at_ research.iiit.ac.in, vkrishna _at_students.iiit.ac.in
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****
# --------------------------------------------------------------------------

#NOTE:
# This script implements the method suggested by Teddy: A Sketch Interface for 3D Freeform Design,
# which was published in SIGRAPH '99 by Takeo Igarishi, Satoshi Matsuoka and Hidenhiko Tanaka from
# University of Tokyo and Tokyo Institute of Technology.


#!/usr/bin/python

#from OpenGL.GL import *;
#from OpenGL.GLU import *;
#from OpenGL.GLUT import *;

import math;
import re;
import sys;
import model;
import poly;
import cal3d;

prune = False
cur_x = 320
cur_y = 240
r_x = 0
r_y = 0
#button = GLUT_LEFT_BUTTON
points = []
triangles = []
inlines = [] 
merged = []
addedtris = []
skeleton = []
adjecency = []

#def init( ):
#	glClearColor( .20, 0.20, .20, 0.0 )
#	#glViewport( 0, 0, globals( )["maxx"], globals( )["maxy"] )
#	glViewport( 0, 0, 640, 480 )
#	glEnable(GL_DEPTH_TEST)
#	glMatrixMode( GL_PROJECTION )
#	glLoadIdentity( )
#	glOrtho( -100, 640, -100, 480, -500.0, 500.0 )
#	#glOrtho( -640, 640, -480, 480, -500.0, 500.0 )
#	#gluPerspective( 60, 1.33, 0.5, 500 )
#	#gluOrtho2D( globals( )["minx"], globals( )["maxx"], globals( )["miny"], globals( )["maxy"] )
#	#gluOrtho2D( 0, 640, 0, 480 )
#	glMatrixMode( GL_MODELVIEW )
#	glLoadIdentity( )
#	#glPolygonMode( GL_FRONT_AND_BACK, GL_LINE)

#create adjecency for given lines
def setAdjecency( lines ):
	global adjecency
	for line in lines:
		i1 = getPointIndex( line.p1 )
		i2 = getPointIndex( line.p2 )
		if( i1 > -1 and i2 > -1 ):
			if( not ( i2 in adjecency[i1] ) ):
				adjecency[i1].append( i2 )
			if( not ( i1 in adjecency[i2] ) ):
				adjecency[i2].append( i1 )
		else:
			print "Could not find the point!!"
			sys.exit(1)
	
def keyboard( key, x, y ):
	if( key == 'p' ):
		globals()["prune"] = not(globals()["prune"])
	elif key == 'r':
		globals()["r_x"] = 0
		globals()["r_y"] = 0
	else:
		sys.exit(0)

#def cammove( button, state, x, y ):
#		if button == GLUT_MIDDLE_BUTTON:
#			globals()["button"]=GLUT_MIDDLE_BUTTON
#			pass
#		elif button == GLUT_RIGHT_BUTTON:
#			globals()["button"]=GLUT_RIGHT_BUTTON
#			pass

def mousemotion( x, y ):
	global button
	if x > globals()["cur_x"]:
		globals()["r_x"] += 1
	elif x < globals()["cur_x"]:
		globals()["r_x"] -= 1
	if y > globals()["cur_y"]:
		globals()["r_y"] += 1
	elif y < globals()["cur_y"]:
		globals()["r_y"] -= 1
	globals()["cur_x"] = x
	globals()["cur_y"] = y

#FIND IF THE TRIANGLE IS TO BE MERGED
def isInsig( line, pIndices = [] ):
	points = globals( )["points"]
	leng = poly.ptDistance( line.p1, line.p2 )
# 	debug_print( ("InlineNew:", line.p1.x, line.p1.y, line.p2.x, line.p2.y) )
	mid = line.getMidPoint( )
# 	debug_print( ("MidPoint:", mid.x, mid.y ) )
# 	debug_print( ("pIndices", pIndices) )
# 	debug_print( ("Len", leng/2.0) )
	for index in pIndices:
		distance = poly.ptDistance( points[index], mid )
		#debug_print( ("Index", index, "Distance", distance, distance>leng/2.0) )
		if( distance > leng/2.0 ):
			#print distance, leng/2.0
			#print " "
			return 0
	#print " "
	return 1

#RETURNS THE TRIANGLE ADJECENT TO THE CURRENT TRIANGLE
def getAdjecent( pruneTris ):
	global triangles
	
	for itr_var1 in xrange( len(triangles) ):
		tris = triangles[itr_var1]
		if tris.processed:
			continue
		counter = 0
		for index in  pruneTris.indices:
			if( index in tris.indices ):
				counter = counter + 1
		#THE ADJECENT TRIANGLE WOULD HAVE ONLY
		#TWO POINTS IN COMMON
		if counter == 2:
			return itr_var1 


def debug_print( args = ( ) ):
	print args

def getPointIndex( pt ):
	global points
	for index in xrange( len( points ) ):
		if poly.isEqualPoint( points[index], pt ):
			return index
	return -1
			
def addJunctionTriangles( testTris, inline ):
	#FINDING THE SKELETON FOR THE JUNCTION TRIANGLE
	sklines = []
	mid = testTris.centroid
	checkAndAdd( mid )
	for l in testTris.lines:
		if not( poly.isEqualLine( l, inline ) ):
			skel = model.Line( )
			skel.setPts( l.getMidPoint( ), mid )
			sklines.append(l)
	if len(sklines) > 2:
		print "SKLINES GREATER THAN 2!!"
	#FIND THE COMMON POINT FOR THE OTHER TWO INTERNAL LINES
	commonPoint = model.Point3D( )
	commonPoint = poly.getCommonPoint( sklines[0], sklines[1] )						
	#FIND THE OTHER POINTS (OF THE LINES FOR MAKING NEW TRIANGLES)
	noncommonpt1 = poly.getOtherPoint( sklines[0], commonPoint )
	noncommonpt2 = poly.getOtherPoint( sklines[1], commonPoint )
	#CONSTRUCT THE NEW TRIANGLES
	#TRIANGLE1
	tmptria = model.Triangle( )
	l1 = model.Line( )
	l1.setPts( commonPoint, noncommonpt1 )
	l2 = model.Line( )
	l2.setPts( noncommonpt1, mid )
	l3 = model.Line( )
	l3.setPts( mid, commonPoint )
	skel = model.Line( )
	skel.setPts( mid, l1.getMidPoint( ));
	checkAndAdd( skel.p1 )
	checkAndAdd( skel.p2 )
	tmptria.addSkeleton( skel )
	tmptria.setLines( [ l1, l2, l3 ] )
	setAdjecency( [l1, l2, l3] )
	#setAdjecency( [l2, l3] )
	globals( )["addedtris"].append( tmptria )

	#TRIANGLE2
	tmptria = model.Triangle( )
	l1 = model.Line( )
	l1.setPts( commonPoint, noncommonpt2 )
	l2 = model.Line( )
	l2.setPts( noncommonpt2, mid )
	l3 = model.Line( )
	l3.setPts( mid, commonPoint )
	skel = model.Line( )
	skel.setPts( mid, l1.getMidPoint( ));
	checkAndAdd( skel.p1 )
	checkAndAdd( skel.p2 )
	tmptria.addSkeleton( skel )
	tmptria.setLines( [ l1, l2, l3 ] )
	setAdjecency( [l1, l2, l3] )
#	setAdjecency( [l2, l3] )

	globals( )["addedtris"].append( tmptria )

def elevateSkel( ):
	global skeleton
	global adjecency
	global points
	global triangles

	processed = []
	counts = []
	distancesum = []

	#MAKING THE POINTS OF THE TRAINGLE POINT TO
	#ELEMENTS IN THE POINTS LIST
	for triangle in triangles:
		indices = []
		for line in triangle.lines:
			indx1 = getPointIndex( line.p1 )
			indx2 = getPointIndex( line.p2 )
			line.p1 = points[indx1]
			line.p2 = points[indx2]
			if not( indx1 in indices ):
				indices.append( indx1 )		
			if not( indx2 in indices ):
				indices.append( indx2 )		
		if len(indices) < 3:
			print "Number of vertices is less"
			sys.exit(1)
		else:
			triangle.setIndices( indices )
	for skline in skeleton:
		p1_index = getPointIndex( skline.p1 )
		p2_index = getPointIndex( skline.p2 )
		print p1_index, p2_index
		dist = 0
		#CHECK IF THE FIRST POINT HAS ALREADY BEEN PROCESSED
		if not(p1_index in processed):
			for index in adjecency[p1_index]:
				dist = dist + poly.ptDistance( points[p1_index], points[index] )
			points[p1_index].z = dist/len(adjecency[p1_index])
			processed.append( p1_index )
			dist = 0

		#CHECK IF THE SECOND POINT HAS ALREADY BEEN PROCESSED
		if not(p2_index in processed):
			for index in adjecency[p2_index]:
				dist = dist + poly.ptDistance( points[p2_index], points[index] )
			points[p2_index].z = dist/len(adjecency[p1_index])
			processed.append( p2_index )
	cal3d.genCal3DSkel( skeleton )

def checkAndAdd( pt ):
	global points
	global adjecency
	index = getPointIndex( pt )
	if( index == -1 ):
		points.append( pt )
		index = len(points)-1
		adjecency.append( [] )
	return index
				
def divideAtSkel( ):
	global triangles
	global addedtris
	global skeleton

	addedtris = [] #creating new set of triangles to add
	newlist = []	#newly created list of triangles
#	print "Triangles List: "
#	printTrisIndices( triangles )
	counter = 0
	for triangle in triangles:
		#SAVE THE SKELETON OF THE STRUCTURE
		if triangle.type != "Terminal":
			skeleton = skeleton + triangle.skeleton 
		#SLEEVE TRIANGLE HAS TO BE DIVIDED INTO THREE TRIANGLES
		if( triangle.type == "Sleeve" and len(triangle.skeleton)> 0):
			triangle.setProcessed( True )	
			inlines = []
			extline = []
			for line in triangle.lines:
				if line.type == "Internal":
					inlines.append( line )
				else:
					extline.append( line )
			commonpoint = poly.getCommonPoint( inlines[0], inlines[1] )
			skline = triangle.skeleton[0]		
			#ADD THE SKELETON VERTICES TO POINTS LIST
			checkAndAdd( skline.p1 )
			checkAndAdd( skline.p2 )
			#THE TOP TRIANGLE IN SLEEVE
			tmpTris = model.Triangle( )
			l1 = skline
			l2 = model.Line( )
			l2.setPts( commonpoint, l1.p1 )
			l3 = model.Line( )
			l3.setPts( commonpoint, l1.p2 )
			tmpTris.setLines( [l1, l2, l3] )
			#setAdjecency( [l1, l2, l3] )
			setAdjecency( [l2, l3] )
			addedtris.append( tmpTris )

			#NEXT TWO TRIANGLES
			oth1 = poly.getOtherPoint( inlines[0], commonpoint )
			oth2 = poly.getOtherPoint( inlines[1], commonpoint )
			m1 = inlines[0].getMidPoint( )
			m2 = inlines[1].getMidPoint( )
			cline = model.Line( )
			if( poly.isEqualPoint( m1, skline.p1 ) ):
				cline.setPts( skline.p1, oth2 )	
			else:
				cline.setPts( skline.p1, oth1 )	

			#SECOND TRIANGLE
			l1 = skline 
			l2 = cline 
			l3 = model.Line( )
			l3.setPts( l2.p2, l1.p2 )
			tmpTris = model.Triangle( )
			tmpTris.setLines( [l1, l2, l3] )	
			#setAdjecency( [l1, l2, l3] )
			setAdjecency( [ l2, l3] )
			addedtris.append( tmpTris )

			#THIRD TRIANGLE
			l1 = extline[0]	
			l2 = cline
			tmppoint = poly.getCommonPoint( extline[0], cline )
			otpt = poly.getOtherPoint( extline[0], tmppoint )
			point = poly.getOtherPoint( cline, tmppoint )
			l3 = model.Line( )
			l3.setPts( otpt, point )
			tmpTris = model.Triangle( )
			tmpTris.setLines( [l1, l2, l3] )
			#setAdjecency( [l1, l2, l3] )
			setAdjecency( [l2, l3] )
			addedtris.append( tmpTris )
		#JUNCTION AND TERMINAL TRIANGLE HAS TO BE DIVIDED INTO TWO TRIANGLE	
		else:
			if len(triangle.skeleton) == 0:
				continue
			triangle.setProcessed(True)
			skline = triangle.skeleton[0]
			#ADD THE SKELETON VERTICES TO POINTS LIST
			othlines = []
			tmid = model.Point3D( )
			base = model.Line( )
			for line in triangle.lines:
				mid = line.getMidPoint( )
				if poly.isEqualPoint( mid, skline.p1 ):
					base = line
					tmid = skline.p1
				elif poly.isEqualPoint( mid, skline.p2 ):
					base = line
					tmid = skline.p2
				else:
					othlines.append( line )
			commonpt = poly.getCommonPoint( othlines[0], othlines[1] )
			index = 0
			othpt = poly.getOtherPoint( othlines[1], commonpt )
			if poly.isEqualPoint( othpt, base.p1 ):
				index = 1
			checkAndAdd( tmid )
			#FIRST TRIANGLE
			tmpTris = model.Triangle( )
			l1 = model.Line( )
			l1.setPts( commonpt, tmid )
			l2 = model.Line( )
			l2.setPts( tmid, base.p1 )
		#	l3 = model.Line( )
		#	l3.setPts( base.p1, commonpt )
			l3 = othlines[index]
			tmpTris.setLines( [l1, l2, l3] )
			#setAdjecency( [l1, l2, l3] )
			setAdjecency( [l2, l3] )
			addedtris.append( tmpTris )
			#SECOND TRIANGLE
			tmpTris = model.Triangle( )
			l1 = model.Line( )
			l1.setPts( commonpt, tmid )
			l2 = model.Line( )
			l2.setPts( tmid, base.p2 )
			#l3 = model.Line( )
			#l3.setPts( base.p2, commonpt )
			#IF INDEX ==0, ASSIGN INDEX == 1 AND VICE VERSA LEN IS 2
			l3 = othlines[len(othlines)-1-index]
			tmpTris.setLines( [l1, l2, l3] )
			#setAdjecency( [l1, l2, l3] )
			setAdjecency( [l2, l3] )
			addedtris.append( tmpTris )
		counter = counter + 1
		
	for tris in triangles:
		if ( not(tris.processed) ):
			newlist.append( tris )
	triangles = newlist + addedtris;


def removeDuplicateTriangles( tlist ):
	triangleList = []
	indexList = []
	for t in tlist:
		ptindex = []
		for l in t.lines:
			idx1 = getPointIndex(l.p1)
			idx2 = getPointIndex(l.p2)
			if not (idx1 in ptindex):
				ptindex.append(idx1)
			if not (idx2 in ptindex):
				ptindex.append(idx2)
		if ptindex in indexList:
			pass
		else:
			indexList.append( ptindex )
			triangleList.append( t )
	return triangleList
	
##########################
#CHECKING THE ERROR OBJECT 
##########################
class MyError(Exception):
	def __init__(self, value):
		self.value = value
	def __str__(self):
		return repr(self.value)

def printTrisIndices( tlist ):
	indexList = []
	tcounter = 0
	for t in tlist:
#		if t.type == "Junction" or t.type == "Terminal" :
			print "Count:",tcounter
			print "Triangle: ", t.type
			ptindex = []
			for l in t.lines:
				idx1 = getPointIndex(l.p1)
				idx2 = getPointIndex(l.p2)
			#	print "indices", (idx1, idx2)
				if not (idx1 in ptindex):
					ptindex.append(idx1)
				if not (idx2 in ptindex):
					ptindex.append(idx2)
			if len(ptindex) < 3:
				print "WTF?"
				raise MyError(ptindex)
			print "ptindex:",ptindex
			print " "
			if ptindex in indexList:
				print "Duplicate Found", ptindex
			else:
				indexList.append( ptindex )
			tcounter = tcounter + 1

def prunetris( ):
	"""Prunes the given triangle list and returns
	the list of pruned triangles"""

	for i in xrange( len( globals( )["triangles"] ) ):
		tris = globals( )["triangles"][i] 
		if tris.type == "Terminal": 
			#FIND THE INTERNAL EDGE
			inline = tris.lines[0]
			if tris.lines[1].type == "Internal":
				inline = tris.lines[1]
			elif tris.lines[2].type == "Internal":
				inline = tris.lines[2]
			#INITIALIZATIONS FOR WHILE LOOP
			testTris = tris
			testTris.setProcessed( True )
			pIndices = [] #to hold the vertex indices to find adjecent
			pIndices = testTris.indices
			tindex = i	#to keep track of which triangles to be merged
			globals( )["merged"] = []
			globals( )["merged"].append( tindex ) #terminal triangle will be murged
			
			while isInsig( inline, pIndices ): #loop while there the triangle is insignificant 
				tindex = getAdjecent( testTris )	
				#ADD THE NEW TRIANGLE TO MERGED LIST
				if tindex == None:
					print "Some thing Wrong: Could not find adjecent triangle"
					break
				globals( )["merged"].append( tindex )
				print "Merged", globals( )["merged"]
				testTris = globals( )["triangles"][tindex]
				testTris.setProcessed( True )
				#THE PROCESS HAS TO STOP IF THE TRIANGLE IS 
				#A JUNCTION TRIANGLE 
				if testTris.type == "Junction":
					print "Found Junction Triangle"
					break
				pIndices = pIndices + testTris.indices

				#FIND THE NEW INTERNAL LINE ( BASE FOR COMBINED TRIANGLES )
				#SET inline TO THAT LINE
 				#debug_print( ("Tris Indices", testTris.indices) )
 				#debug_print( ("InlineCur:", getPointIndex( inline.p1 ), getPointIndex( inline.p2 ) ) )
				for line in testTris.lines:
 					#debug_print( ("LineInTris:", getPointIndex( line.p1 ), getPointIndex( line.p2 ) ) )
					if line.type == "Internal":
						#CHECK IF THIS IS PREVIOUS INTERNAL EDGE
						if( poly.isEqualLine( line, inline ) ):
							continue 
						else:
							#debug_print( ("Inline Changing") )
							inline = line
							#debug_print( ("InlineNew:", getPointIndex(inline.p1), getPointIndex( inline.p2 ) ) )
							break
			#ADD THE FINAL INLINE (internal line) TO INLINES 
			globals( )["inlines"].append( inline )	#(used for drawing circles)	
			#IF ONLY ONE TRIANGLE (SELF) THEN CONTINUE
			if len( globals( )["merged"] ) <= 1 :
				testTris.setProcessed( False )
				continue

			#MERGE THE TRIANGLES WHICH ARE GROUPED IN MERGED LIST AND CREATE
			#FAN TRIANGULATION OR MIDPOINT TRIANGULATION BASED ON JUNCTION TRIANGLE MERGE OR NOT 
			for t in globals( )["merged"]:
				curtris = globals( )["triangles"][t]
				extLines = []
				for l in curtris.lines:
					if l.type =="External":
						extLines.append( l )
				mid = model.Point3D( )
				if testTris.type == "Junction":
					mid = testTris.centroid
					addJunctionTriangles( testTris, inline )
					#testTris.setProcessed( False )
				else:
					mid = inline.getMidPoint( )
				#ADD NEW POINT TO THE POINTS LIST
				checkAndAdd( mid )

				for extline in extLines:
					tmpTria = model.Triangle( )
					i1 = getPointIndex( extline.p1 )
					i2 = getPointIndex( extline.p2 )
					i3 = getPointIndex( mid )
					l1 = model.Line( )
					l1.setPts( extline.p1, extline.p2 )
					l1.setType( "External" )
					l2 = model.Line( )
					l2.setPts( extline.p1, mid ) 
					l2.setType( )
					l3 = model.Line( )
					l3.setPts( mid, extline.p2 ) 
					l3.setType( )
					tmpTria.setLines( [ l1, l2, l3 ] )
					tmpTria.setIndices( (i1, i2, i3) )
					globals( )["addedtris"].append( tmpTria )
					
	newlist = []
	for t in globals( )["triangles"]:
		if not(t.processed) :
			newlist.append( t )
	#REMOVING DUPLICATE TRIANGLES FROM ADDED TRIANGELS	
	globals( )["addedtris"] = removeDuplicateTriangles( globals( )["addedtris"] )
	globals( )["triangles"] = newlist + globals( )["addedtris"]

	divideAtSkel( );
	elevateSkel( );

def loadfile( fname ):
	"""Loading the model that has been generated 
	after triangulation of the initial drawn model"""
	pList = globals( )["points"]
	tList = globals( )["triangles"]
	adjList = globals( )["adjecency"]

	#loading the points of model 
	nodefname = fname + ".node"
	fp = open( nodefname, "r" )
	line = fp.readline( )
	tokens = line.split( ' ' )
	#print fname, " ", tokens[0] 
	for i in xrange( int(tokens[0]) ):
		line = fp.readline( )
		(nline,num) = re.subn(' +',' ', line )
		tokens = nline.split( ' ' )
		tmp = model.Point3D( )
		tmp.setVal( int( tokens[2] ), int( tokens[3] ), 0 ) 
		pList.append( tmp )
		#creating an empty adjecency list
		adjList.append( [] )
	fp.close( )

	#loading the triangles of models
	trisfname = fname + ".ele"
	fp = open( trisfname, "r" )
	line = fp.readline( )
	tokens = line.split( ' ' )	
	global maxx, minx
	global maxy, miny
	maxx = maxy = 0
	minx = miny = 640
	for i in xrange( int( tokens[0] ) ):
		line = fp.readline( )
		(nline,num) = re.subn(' +',' ', line )
		tokens = nline.split( ' ' )
		( i1, i2, i3 ) = ( int(tokens[2]), int(tokens[3]), int(tokens[4]) )
		( p1, p2, p3 ) = ( pList[int(tokens[2])-1], pList[int(tokens[3])-1], pList[int(tokens[4])-1] ) 

		l1 = model.Line( )
		if( i2 == (i1 + 1) or  i2 == ( i1 - 1 )  ):
			l1.setType( "External" )	
		elif( (i2 == 1 and i1 == len(pList)) or (i2 == 1 and i1 == len(pList)) ):
			l1.setType( "External" )	
		l1.setPts( p1, p2 )

		l2 = model.Line( )
		if( i2 == (i3 + 1) or  i2 == ( i3 - 1 ) ):
			l2.setType( "External" )	
		elif( (i2 == 1 and i3 == len(pList)) or (i3 == 1 and i2 == len(pList)) ):
			l2.setType( "External" )	
		l2.setPts( p2, p3 )

		l3 = model.Line( )
		if( i3 == (i1 + 1) or  i3 == ( i1 - 1 ) ):
			l3.setType( "External" )	
		elif( (i3 == 1 and i1 == len(pList)) or (i1 == 1 and i3 == len(pList)) ):
			l3.setType( "External" )	
		l3.setPts( p3, p1 )

		tmpTris = model.Triangle( )
		tmpTris.setLines( [ l1, l2, l3 ] )
		tmpTris.setIndices( ( i1-1, i2-1, i3-1 ) )
		tpt = model.Point3D()
		tpt.x = int(math.ceil(( p1.x + p2.x + p3.x )/3.0))
		tpt.y = int(math.ceil(( p1.y + p2.y + p3.y )/3.0))
		tpt.z = 0
		tmpTris.setCentroid( tpt )
		tmpTris.setSkeleton( )
		tList.append( tmpTris );
	fp.close( )
#	if ( globals( )["prune"] ):
	prunetris( )
	#print "Number of triangles:", len(tList)

#def setColor( line ):
#	if line.type == "External":
#		glColor3f( 1, 0, 0 )
#	else:
#		glColor3f( 1, 1, 1 )
		
#def drawMesh( ):
#	global skeleton
#	global points
#	if len( skeleton ) > 0 : 
#		glColor3f( 0, 0, 0 )
#		glLineWidth( 4 )
#		glBegin( GL_LINES )
#		for skline in skeleton:
#
#			indx1 = getPointIndex( skline.p1 )
#			indx2 = getPointIndex( skline.p2 )
#			p1 = points[indx1];
#			p2 = points[indx2];
#			p1 = skline.p1
#			p2 = skline.p2
##			if indx1 == -1 or indx2 == -1:
##				print "---------",p1.x, p1.y, p1.z
##				print "---------",p2.x, p2.y, p2.z
##				sys.exit(1)
#			glVertex3f( p1.x, p1.y, 0 )
#			glVertex3f( p2.x, p2.y, 0 )
#		glEnd( )
#
#	glColor3f( 1, 1, 1 )
#	for tris in globals( )["triangles"]:
#		l1 = tris.lines[0]
#		l2 = tris.lines[1]
#		l3 = tris.lines[2]
#		glLineWidth( 1 )
#		glBegin( GL_LINES )
#		setColor( l1 )
#		glVertex3f( l1.p1.x, l1.p1.y, l1.p1.z )
#		glVertex3f( l1.p2.x, l1.p2.y, l1.p2.z )
#		
#		setColor( l2 )
#		glVertex3f( l2.p1.x, l2.p1.y, l2.p1.z )
#		glVertex3f( l2.p2.x, l2.p2.y, l2.p2.z )
#
#		setColor( l3 )
#		glVertex3f( l3.p1.x, l3.p1.y, l3.p1.z )
#		glVertex3f( l3.p2.x, l3.p2.y, l3.p2.z )
#		glEnd( )
#
#def display( ):
#	global skeleton
#	global points
#	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )
#	glLoadIdentity( );
##	gluLookAt( cx, cy, cz, lx, ly, lz, 0, 1, 0 );
##	gluLookAt( 0, 0, 1, 0, 0, -10, 0, 1, 0 );
#	glRotatef( globals( )["r_x"], 0, 1, 0 )
#	glRotatef( globals( )["r_y"], 1, 0, 0 )
#	drawMesh( )
#	glPushMatrix( )
#	glScalef( 1, 1, -1 )
#	drawMesh( )
#	glPopMatrix( )	
#
#	#drawCircle( )
#	glFlush( )
#	glutSwapBuffers( )
#
#if __name__=="__main__":
#	glutInit( sys.argv )
#	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH )
#	#loadfile( "first.1" )
#	if len( sys.argv ) > 1 :
#		loadfile( sys.argv[1] )
#	else:
#		loadfile( "first.1" )
#		
#	glutInitWindowSize( 640, 480 )
#	#glutInitWindowSize( globals()["maxx"], globals( )["maxy"])
#	glutCreateWindow( "Dispaly Window" )
#	init( )
#	glutDisplayFunc( display )
#	glutIdleFunc( display )
#	glutKeyboardFunc( keyboard )
#	glutMotionFunc( mousemotion )
#	glutMouseFunc( cammove )
#	glutMainLoop( )
