# --------------------------------------------------------------------------
# PyTeddy version .9 Apr 14, 2005
# Program versions: Blender 2.36+
# --------------------------------------------------------------------------
# ***** BEGIN GPL LICENSE BLOCK *****
#
# Copyright (C) 2005: Vamsi Krishna.V vkrishna _at_ research.iiit.ac.in, vkrishna _at_students.iiit.ac.in
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****
# --------------------------------------------------------------------------

import model;
import sys;
import math;
import string;

def ptDistance( p1, p2 ):
	xval = p1.x - p2.x
	yval = p1.y - p2.y
	#zval = p1.z - p2.z
	zval = 0
	return math.sqrt( xval*xval + yval*yval + zval*zval )

def isEqualLine( l1, l2 ):
	if( ( isEqualPoint( l1.p1, l2.p1 ) and isEqualPoint( l1.p2, l2.p2 ) ) ):
		return True
	elif( isEqualPoint( l1.p1, l2.p2 ) and isEqualPoint( l1.p2, l2.p1 ) ):
		return True
	else:
		return False

def getCommonPoint( l1, l2 ):
	if isEqualPoint( l1.p1, l2.p1 ) or isEqualPoint( l1.p1, l2.p2 ):
		return l1.p1
	elif isEqualPoint( l1.p2, l2.p1 ) or isEqualPoint( l1.p2, l2.p2 ):
		return l1.p2

def getOtherPoint( l, pt ):
	if( isEqualPoint( l.p1, pt ) ):
		return l.p2
	else:
		return l.p1 

def isEqualPoint( p1, p2 ):
	if p1.x == p2.x and p1.y == p2.y: # and p1.z == p2.z: 
		return True
	return False

def polyTriangulate( lines = [] ):
	"""FOR TRIANGULATING THE POLYGON 
	FORMED BY THE LINES"""
	triangles = []

	return triangles

def polyConstruct( points = [] ):
	"""FOR CONSTRUCTING THE POLYGONAL 
	APPROXIMATION OF THE GIVEN INPUT SILHOUTE"""
	i = 0
	prevpt = points[0]
	while i < len(points):
		if( points[i].deleted ):
				continue
		else:
			if( ptDistance( prevpt, points[i] ) > 30 ):
				prevpt = points[i]
			else:
				points[i].deleted = True
		i = i + 1
	print "Length of points:",len(points)
	newlist = []
	for pt in points:
		if pt.deleted:
			continue
		newlist.append(pt)
	print "Length of approximate:",len(newlist)
	return newlist
	
if __name__ =="__main__":
	points = [];
	for i in xrange(10):
		tmp = model.Point3D( )
		tmp.setVal( i, i, 0 )
		points.append( tmp )
	approx = polyConstruct( points )
	print "len of actual = ", len(points)
	print "len of approx = ", len(approx)
	for i in approx:
		print "<", i.p1.x, ",", i.p1.y, ",", i.p1.z,"> <", i.p2.x, ",", i.p2.y, ",", i.p2.z, ">"
